#ifndef UNDIRECTED_GRAPH_H
#define UNDIRECTED_GRAPH_H

#include <vector>
using std::vector;

#include <climits>

class Edge;

class Node
{
    public:

    	Node(int);                 //The constructor.

    	int id;                    //For the id of the node.
    	bool visited;              //For checking visited nodes.
    	int distance;

    	vector <Edge*> adj;       //The adjacent nodes.
};

class Edge
{
    public:

        Edge(Node*, Node*, int);   //The constructor.

    	Node* start_Node;          //The start_Node start of the edge.
    	Node* end_Node;            //The end of the edge.
    	int w;                     //The weight of the edge.

    	bool isConnected(Node* node1, Node* node2)  //Checks if the nodes are connected.
    	{
    		return((node1 == this->start_Node && node2 == this->end_Node) ||
    		       (node1 == this->end_Node   && node2 == this->start_Node));
    	}
};

class Graph
{
    public:

        Graph(int);                    //The Constructor.

    	int max_Nodes;                 //Maximum Number of allowed Nodes.

    	vector <Edge*> edges_List;     //For storing the edges of the graph.
    	vector <Node*> nodes_List;     //For storing the nodes of the graph.

    	void insertEdge(int, int, int);

    	int getNumNodes();
    	int getNumEdges();
};

#endif
